# RuleBasedBreakIterator Class Reference

A subclass of BreakIterator whose behavior is specified using a list of rules. More...

`#include <rbbi.h>`

Inheritance diagram for RuleBasedBreakIterator:

## Public Member Functions
| RuleBasedBreakIterator ()
| Default constructor.
| RuleBasedBreakIterator (const RuleBasedBreakIterator &that)
| Copy constructor.
| RuleBasedBreakIterator (const UnicodeString &rules, UParseError &parseError, UErrorCode &status)
| Construct a RuleBasedBreakIterator from a set of rules supplied as a string.
| RuleBasedBreakIterator (UDataMemory *image, UErrorCode &status)
| This constructor uses the udata interface to create a BreakIterator whose internal tables live in a memory-mapped file.
virtual | ~RuleBasedBreakIterator ()
| Destructor.
RuleBasedBreakIterator & | operator= (const RuleBasedBreakIterator &that)
| Assignment operator.
virtual UBool | operator== (const BreakIterator &that) const
| Equality operator.
UBool | operator!= (const BreakIterator &that) const
| Not-equal operator.
virtual BreakIterator * | clone () const
| Returns a newly-constructed RuleBasedBreakIterator with the same behavior, and iterating over the same text, as this one.
virtual int32_t | hashCode (void) const
| Compute a hash code for this BreakIterator.
virtual const UnicodeString & | getRules (void) const
| Returns the description used to create this iterator.
virtual CharacterIterator & | getText (void) const
virtual UText * | getUText (UText *fillIn, UErrorCode &status) const
| Get a UText for the text being analyzed.
virtual void | adoptText (CharacterIterator *newText)
| Set the iterator to analyze a new piece of text.
virtual void | setText (const UnicodeString &newText)
| Set the iterator to analyze a new piece of text.
virtual void | setText (UText *text, UErrorCode &status)
| Reset the break iterator to operate over the text represented by the UText.
virtual int32_t | first (void)
| Sets the current iteration position to the beginning of the text.
virtual int32_t | last (void)
| Sets the current iteration position to the end of the text.
virtual int32_t | next (int32_t n)
| Advances the iterator either forward or backward the specified number of steps.
virtual int32_t | next (void)
| Advances the iterator to the next boundary position.
virtual int32_t | previous (void)
| Moves the iterator backwards, to the last boundary preceding this one.
virtual int32_t | following (int32_t offset)
| Sets the iterator to refer to the first boundary position following the specified position.
virtual int32_t | preceding (int32_t offset)
| Sets the iterator to refer to the last boundary position before the specified position.
virtual UBool | isBoundary (int32_t offset)
| Returns true if the specfied position is a boundary position.
virtual int32_t | current (void) const
| Returns the current iteration position.
virtual int32_t | getRuleStatus () const
| Return the status tag from the break rule that determined the most recently returned break position.
virtual int32_t | getRuleStatusVec (int32_t *fillInVec, int32_t capacity, UErrorCode &status)
| Get the status (tag) values from the break rule(s) that determined the most recently returned break position.
virtual UClassID | getDynamicClassID (void) const
| Returns a unique class ID POLYMORPHICALLY.
virtual BreakIterator * | createBufferClone (void *stackBuffer, int32_t &BufferSize, UErrorCode &status)
| Thread safe client-buffer-based cloning operation Do NOT call delete on a safeclone, since 'new' is not used to create it.
virtual const uint8_t * | getBinaryRules (uint32_t &length)
| Return the binary form of compiled break rules, which can then be used to create a new break iterator at some time in the future.
## Static Public Member Functions
static UClassID | getStaticClassID (void)
| Returns the class ID for this class.
## Protected Types
enum | EDontAdopt { kDontAdopt }
| Constant to be used in the constructor RuleBasedBreakIterator(RBBIDataHeader*, EDontAdopt, UErrorCode &); which does not adopt the memory indicated by the RBBIDataHeader* parameter. More...
## Protected Member Functions
| RuleBasedBreakIterator (RBBIDataHeader *data, UErrorCode &status)
| Constructor from a flattened set of RBBI data in malloced memory.
| RuleBasedBreakIterator (const RBBIDataHeader *data, enum EDontAdopt dontAdopt, UErrorCode &status)
| Constructor from a flattened set of RBBI data in memory which need not be malloced (e.g.
virtual void | reset (void)
| Dumps caches and performs other actions associated with a complete change in text or iteration position.
virtual void | setBreakType (int32_t type)
| Set the type of the break iterator.
void | init ()
| Common initialization function, used by constructors and bufferClone.
int32_t | checkDictionary (int32_t startPos, int32_t endPos, UBool reverse)
| This is the function that actually implements dictionary-based breaking.
## Protected Attributes
UText * | fText
| The UText through which this BreakIterator accesses the text.
CharacterIterator * | fCharIter
| A character iterator that refers to the same text as the UText, above.
StringCharacterIterator * | fSCharIter
| When the input text is provided by a UnicodeString, this will point to a characterIterator that wraps that data.
UCharCharacterIterator * | fDCharIter
| When the input text is provided by a UText, this dummy CharacterIterator over an empty string will be returned from getText().
RBBIDataWrapper * | fData
| The rule data for this BreakIterator instance.
int32_t | fLastRuleStatusIndex
| Index of the Rule {tag} values for the most recent match.
UBool | fLastStatusIndexValid
| Rule tag value valid flag.
uint32_t | fDictionaryCharCount
| Counter for the number of characters encountered with the "dictionary" flag set.
int32_t * | fCachedBreakPositions
| When a range of characters is divided up using the dictionary, the break positions that are discovered are stored here, preventing us from having to use either the dictionary or the state table again until the iterator leaves this range of text.
int32_t | fNumCachedBreakPositions
| The number of elements in fCachedBreakPositions.
int32_t | fPositionInCache
| if fCachedBreakPositions is not null, this indicates which item in the cache the current iteration position refers to
UStack * | fLanguageBreakEngines
| If present, UStack of LanguageBreakEngine objects that might handle dictionary characters.
UnhandledEngine * | fUnhandledBreakEngine
| If present, the special LanguageBreakEngine used for handling characters that are in the dictionary set, but not handled by any LangugageBreakEngine.
int32_t | fBreakType
| The type of the break iterator, or -1 if it has not been set.
## Friends
class | RBBIRuleBuilder
class | BreakIterator

## Detailed Description

A subclass of BreakIterator whose behavior is specified using a list of rules.

Instances of this class are most commonly created by the factory methods of BreakIterator::createWordInstance(), BreakIterator::createLineInstance(), etc., and then used via the abstract API in class BreakIterator

See the ICU User Guide for information on Break Iterator Rules.

This class is not intended to be subclassed. (Class DictionaryBasedBreakIterator is a subclass, but that relationship is effectively internal to the ICU implementation. The subclassing interface to RulesBasedBreakIterator is not part of the ICU API, and may not remain stable.

Definition at line 65 of file rbbi.h.

## Member Enumeration Documentation

enum RuleBasedBreakIterator::EDontAdopt`[protected]`

Constant to be used in the constructor RuleBasedBreakIterator(RBBIDataHeader*, EDontAdopt, UErrorCode &); which does not adopt the memory indicated by the RBBIDataHeader* parameter.

Internal:
  Do not use. This API is for internal use only.

Definition at line 181 of file rbbi.h.

## Constructor & Destructor Documentation

RuleBasedBreakIterator::RuleBasedBreakIterator | ( | RBBIDataHeader * | data,
|  | UErrorCode & | status |
| ) |  |  | `[protected]`

Constructor from a flattened set of RBBI data in malloced memory.

RulesBasedBreakIterators built from a custom set of rules are created via this constructor; the rules are compiled into memory, then the break iterator is constructed here.

The break iterator adopts the memory, and will free it when done.

Internal:
  Do not use. This API is for internal use only.

RuleBasedBreakIterator::RuleBasedBreakIterator | ( | const RBBIDataHeader * | data,
|  | enum EDontAdopt | dontAdopt,
|  | UErrorCode & | status |
| ) |  |  | `[protected]`

Constructor from a flattened set of RBBI data in memory which need not be malloced (e.g.

it may be a memory-mapped file, etc.).

This version does not adopt the memory, and does not free it when done.

Internal:
  Do not use. This API is for internal use only.

RuleBasedBreakIterator::RuleBasedBreakIterator | ( |  | ) |

Default constructor.

Creates an empty shell of an iterator, with no rules or text to iterate over. Object can subsequently be assigned to.

Stable:
  ICU 2.2

RuleBasedBreakIterator::RuleBasedBreakIterator | ( | const RuleBasedBreakIterator & | that | ) |

Copy constructor.

Will produce a break iterator with the same behavior, and which iterates over the same text, as the one passed in.

Parameters:

  | that | The RuleBasedBreakIterator passed to be copied

Stable:
  ICU 2.0

RuleBasedBreakIterator::RuleBasedBreakIterator | ( | const UnicodeString & | rules,
|  | UParseError & | parseError,
|  | UErrorCode & | status |
| ) |  |  |

Construct a RuleBasedBreakIterator from a set of rules supplied as a string.

Parameters:

  | rules | The break rules to be used.
  | parseError | In the event of a syntax error in the rules, provides the location within the rules of the problem.
  | status | Information on any errors encountered.

Stable:
  ICU 2.2

RuleBasedBreakIterator::RuleBasedBreakIterator | ( | UDataMemory * | image,
|  | UErrorCode & | status |
| ) |  |  |

This constructor uses the udata interface to create a BreakIterator whose internal tables live in a memory-mapped file.

"image" is an ICU UDataMemory handle for the pre-compiled break iterator tables.

Parameters:

  | image | handle to the memory image for the break iterator data. Ownership of the UDataMemory handle passes to the Break Iterator, which will be responsible for closing it when it is no longer needed.
  | status | Information on any errors encountered.

See also:
  udata_open

  getBinaryRules

Stable:
  ICU 2.8

virtual RuleBasedBreakIterator::~RuleBasedBreakIterator | ( |  | ) | `[virtual]`

Destructor.

Stable:
  ICU 2.0

## Member Function Documentation

virtual void RuleBasedBreakIterator::adoptText | ( | CharacterIterator * | newText | ) | `[virtual]`

Set the iterator to analyze a new piece of text.

This function resets the current iteration position to the beginning of the text.

Parameters:

  | newText | An iterator over the text to analyze. The BreakIterator takes ownership of the character iterator. The caller MUST NOT delete it!

Stable:
  ICU 2.0

Implements BreakIterator.

int32_t RuleBasedBreakIterator::checkDictionary | ( | int32_t | startPos,
|  | int32_t | endPos,
|  | UBool | reverse |
| ) |  |  | `[protected]`

This is the function that actually implements dictionary-based breaking.

Covering at least the range from startPos to endPos, it checks for dictionary characters, and if it finds them determines the appropriate object to deal with them. It may cache found breaks in fCachedBreakPositions as it goes. It may well also look at text outside the range startPos to endPos. If going forward, endPos is the normal Unicode break result, and if goind in reverse, startPos is the normal Unicode break result

Parameters:

  | startPos | The start position of a range of text
  | endPos | The end position of a range of text
  | reverse | The call is for the reverse direction

Internal:
  Do not use. This API is for internal use only.

virtual BreakIterator* RuleBasedBreakIterator::clone | ( |  | ) | const`[virtual]`

Returns a newly-constructed RuleBasedBreakIterator with the same behavior, and iterating over the same text, as this one.

Differs from the copy constructor in that it is polymorphic, and will correctly clone (copy) a derived class. clone() is thread safe. Multiple threads may simultaeneously clone the same source break iterator.

Returns:
  a newly-constructed RuleBasedBreakIterator

Stable:
  ICU 2.0

Implements BreakIterator.

virtual BreakIterator* RuleBasedBreakIterator::createBufferClone | ( | void * | stackBuffer,
|  | int32_t & | BufferSize,
|  | UErrorCode & | status |
| ) |  |  | `[virtual]`

Thread safe client-buffer-based cloning operation Do NOT call delete on a safeclone, since 'new' is not used to create it.

Parameters:

  | stackBuffer | user allocated space for the new clone. If NULL new memory will be allocated. If buffer is not large enough, new memory will be allocated.
  | BufferSize | reference to size of allocated space. If BufferSize == 0, a sufficient size for use in cloning will be returned ('pre-flighting') If BufferSize is not enough for a stack-based safe clone, new memory will be allocated.
  | status | to indicate whether the operation went on smoothly or there were errors An informational status value, U_SAFECLONE_ALLOCATED_ERROR, is used if any allocations were necessary.

Returns:
  pointer to the new clone

Stable:
  ICU 2.0

Implements BreakIterator.

virtual int32_t RuleBasedBreakIterator::current | ( | void |  | ) | const`[virtual]`

Returns the current iteration position.

Returns:
  The current iteration position.

Stable:
  ICU 2.0

Implements BreakIterator.

virtual int32_t RuleBasedBreakIterator::first | ( | void |  | ) | `[virtual]`

Sets the current iteration position to the beginning of the text.

Returns:
  The offset of the beginning of the text.

Stable:
  ICU 2.0

Implements BreakIterator.

virtual int32_t RuleBasedBreakIterator::following | ( | int32_t | offset | ) | `[virtual]`

Sets the iterator to refer to the first boundary position following the specified position.

Parameters:

  | offset | The position from which to begin searching for a break position.

Returns:
  The position of the first break after the current position.

Stable:
  ICU 2.0

Implements BreakIterator.

virtual const uint8_t* RuleBasedBreakIterator::getBinaryRules | ( | uint32_t & | length | ) | `[virtual]`

Return the binary form of compiled break rules, which can then be used to create a new break iterator at some time in the future.

Creating a break iterator from pre-compiled rules is much faster than building one from the source form of the break rules.

The binary data can only be used with the same version of ICU and on the same platform type (processor endian-ness)

Parameters:

  | length | Returns the length of the binary data. (Out paramter.)

Returns:
  A pointer to the binary (compiled) rule data. The storage belongs to the RulesBasedBreakIterator object, not the caller, and must not be modified or deleted.

Internal:
  Do not use. This API is for internal use only.

virtual UClassID RuleBasedBreakIterator::getDynamicClassID | ( | void |  | ) | const`[virtual]`

Returns a unique class ID POLYMORPHICALLY.

Pure virtual override. This method is to implement a simple version of RTTI, since not all C++ compilers support genuine RTTI. Polymorphic operator==() and clone() methods call this method.

Returns:
  The class ID for this object. All objects of a given class have the same class ID. Objects of other classes have different class IDs.

Stable:
  ICU 2.0

Implements BreakIterator.

virtual const UnicodeString& RuleBasedBreakIterator::getRules | ( | void |  | ) | const`[virtual]`

Returns the description used to create this iterator.

Returns:
  the description used to create this iterator

Stable:
  ICU 2.0

virtual int32_t RuleBasedBreakIterator::getRuleStatus | ( |  | ) | const`[virtual]`

Return the status tag from the break rule that determined the most recently returned break position.

For break rules that do not specify a status, a default value of 0 is returned. If more than one break rule would cause a boundary to be located at some position in the text, the numerically largest of the applicable status values is returned.

Of the standard types of ICU break iterators, only word break and line break provide status values. The values are defined in the header file ubrk.h. For Word breaks, the status allows distinguishing between words that contain alphabetic letters, "words" that appear to be numbers, punctuation and spaces, words containing ideographic characters, and more. For Line Break, the status distinguishes between hard (mandatory) breaks and soft (potential) break positions.

`getRuleStatus()` can be called after obtaining a boundary position from `next()`, `previous()`, or any other break iterator functions that returns a boundary position.

When creating custom break rules, one is free to define whatever status values may be convenient for the application.

Note: this function is not thread safe. It should not have been declared const, and the const remains only for compatibility reasons. (The function is logically const, but not bit-wise const).

Returns:
  the status from the break rule that determined the most recently returned break position.

See also:
  UWordBreak

Stable:
  ICU 2.2

virtual int32_t RuleBasedBreakIterator::getRuleStatusVec | ( | int32_t * | fillInVec,
|  | int32_t | capacity,
|  | UErrorCode & | status |
| ) |  |  | `[virtual]`

Get the status (tag) values from the break rule(s) that determined the most recently returned break position.

The returned status value(s) are stored into an array provided by the caller. The values are stored in sorted (ascending) order. If the capacity of the output array is insufficient to hold the data, the output will be truncated to the available length, and a U_BUFFER_OVERFLOW_ERROR will be signaled.

Parameters:

  | fillInVec | an array to be filled in with the status values.
  | capacity | the length of the supplied vector. A length of zero causes the function to return the number of status values, in the normal way, without attemtping to store any values.
  | status | receives error codes.

Returns:
  The number of rule status values from rules that determined the most recent boundary returned by the break iterator. In the event of a U_BUFFER_OVERFLOW_ERROR, the return value is the total number of status values that were available, not the reduced number that were actually returned.

See also:
  getRuleStatus

Stable:
  ICU 3.0

static UClassID RuleBasedBreakIterator::getStaticClassID | ( | void |  | ) | `[static]`

Returns the class ID for this class.

This is useful only for comparing to a return value from getDynamicClassID(). For example:

Base* polymorphic_pointer = createPolymorphicObject(); if (polymorphic_pointer->getDynamicClassID() == Derived::getStaticClassID()) ...

Returns:
  The class ID for all objects of this class.

Stable:
  ICU 2.0

virtual CharacterIterator& RuleBasedBreakIterator::getText | ( | void |  | ) | const`[virtual]`

Return a CharacterIterator over the text being analyzed. The returned character iterator is owned by the break iterator, and must not be deleted by the caller. Repeated calls to this function may return the same CharacterIterator.

The returned character iterator must not be used concurrently with the break iterator. If concurrent operation is needed, clone the returned character iterator first and operate on the clone.

When the break iterator is operating on text supplied via a UText, this function will fail. Lacking any way to signal failures, it returns an CharacterIterator containing no text. The function getUText() provides similar functionality, is reliable, and is more efficient.

TODO: deprecate this function?

Returns:
  An iterator over the text being analyzed.

Stable:
  ICU 2.0

Implements BreakIterator.

virtual UText* RuleBasedBreakIterator::getUText | ( | UText * | fillIn,
|  | UErrorCode & | status |
| ) |  |  | const`[virtual]`

Get a UText for the text being analyzed.

The returned UText is a shallow clone of the UText used internally by the break iterator implementation. It can safely be used to access the text without impacting any break iterator operations, but the underlying text itself must not be altered.

Parameters:

  | fillIn | A UText to be filled in. If NULL, a new UText will be allocated to hold the result.
  | status | receives any error codes.

Returns:
  The current UText for this break iterator. If an input UText was provided, it will always be returned.

Stable:
  ICU 3.4

Implements BreakIterator.

virtual int32_t RuleBasedBreakIterator::hashCode | ( | void |  | ) | const`[virtual]`

Compute a hash code for this BreakIterator.

Returns:
  A hash code

Stable:
  ICU 2.0

void RuleBasedBreakIterator::init | ( |  | ) | `[protected]`

Common initialization function, used by constructors and bufferClone.

(Also used by DictionaryBasedBreakIterator::createBufferClone().)

Internal:
  Do not use. This API is for internal use only.

virtual UBool RuleBasedBreakIterator::isBoundary | ( | int32_t | offset | ) | `[virtual]`

Returns true if the specfied position is a boundary position.

As a side effect, leaves the iterator pointing to the first boundary position at or after "offset".

Parameters:

  | offset | the offset to check.

Returns:
  True if "offset" is a boundary position.

Stable:
  ICU 2.0

Implements BreakIterator.

virtual int32_t RuleBasedBreakIterator::last | ( | void |  | ) | `[virtual]`

Sets the current iteration position to the end of the text.

Returns:
  The text's past-the-end offset.

Stable:
  ICU 2.0

Implements BreakIterator.

virtual int32_t RuleBasedBreakIterator::next | ( | void |  | ) | `[virtual]`

Advances the iterator to the next boundary position.

Returns:
  The position of the first boundary after this one.

Stable:
  ICU 2.0

Implements BreakIterator.

virtual int32_t RuleBasedBreakIterator::next | ( | int32_t | n | ) | `[virtual]`

Advances the iterator either forward or backward the specified number of steps.

Negative values move backward, and positive values move forward. This is equivalent to repeatedly calling next() or previous().

Parameters:

  | n | The number of steps to move. The sign indicates the direction (negative is backwards, and positive is forwards).

Returns:
  The character offset of the boundary position n boundaries away from the current one.

Stable:
  ICU 2.0

Implements BreakIterator.

UBool RuleBasedBreakIterator::operator!= | ( | const BreakIterator & | that | ) | const`[inline]`

Not-equal operator.

If operator== returns TRUE, this returns FALSE, and vice versa.

Parameters:

  | that | The BreakIterator to be compared for inequality

Returns:
  TRUE if both BreakIterators are not same.

Stable:
  ICU 2.0

Reimplemented from BreakIterator.

Definition at line 714 of file rbbi.h.

References operator==().

RuleBasedBreakIterator& RuleBasedBreakIterator::operator= | ( | const RuleBasedBreakIterator & | that | ) |

Assignment operator.

Sets this iterator to have the same behavior, and iterate over the same text, as the one passed in.

Parameters:

  | that | The RuleBasedBreakItertor passed in

Returns:
  the newly created RuleBasedBreakIterator

Stable:
  ICU 2.0

virtual UBool RuleBasedBreakIterator::operator== | ( | const BreakIterator & | that | ) | const`[virtual]`

Equality operator.

Returns TRUE if both BreakIterators are of the same class, have the same behavior, and iterate over the same text.

Parameters:

  | that | The BreakIterator to be compared for equality

Returns:
  TRUE if both BreakIterators are of the same class, have the same behavior, and iterate over the same text.

Stable:
  ICU 2.0

Implements BreakIterator.

Referenced by operator!=().

virtual int32_t RuleBasedBreakIterator::preceding | ( | int32_t | offset | ) | `[virtual]`

Sets the iterator to refer to the last boundary position before the specified position.

Parameters:

  | offset | The position to begin searching for a break from.

Returns:
  The position of the last boundary before the starting position.

Stable:
  ICU 2.0

Implements BreakIterator.

virtual int32_t RuleBasedBreakIterator::previous | ( | void |  | ) | `[virtual]`

Moves the iterator backwards, to the last boundary preceding this one.

Returns:
  The position of the last boundary position preceding this one.

Stable:
  ICU 2.0

Implements BreakIterator.

virtual void RuleBasedBreakIterator::reset | ( | void |  | ) | `[protected, virtual]`

Dumps caches and performs other actions associated with a complete change in text or iteration position.

Internal:
  Do not use. This API is for internal use only.

virtual void RuleBasedBreakIterator::setBreakType | ( | int32_t | type | ) | `[protected, virtual]`

Set the type of the break iterator.

Internal:
  Do not use. This API is for internal use only.

virtual void RuleBasedBreakIterator::setText | ( | UText * | text,
|  | UErrorCode & | status |
| ) |  |  | `[virtual]`

Reset the break iterator to operate over the text represented by the UText.

The iterator position is reset to the start.

This function makes a shallow clone of the supplied UText. This means that the caller is free to immediately close or otherwise reuse the Utext that was passed as a parameter, but that the underlying text itself must not be altered while being referenced by the break iterator.

Parameters:

  | text | The UText used to change the text.
  | status | Receives any error codes.

Stable:
  ICU 3.4

Implements BreakIterator.

virtual void RuleBasedBreakIterator::setText | ( | const UnicodeString & | newText | ) | `[virtual]`

Set the iterator to analyze a new piece of text.

This function resets the current iteration position to the beginning of the text.

Parameters:

  | newText | The text to analyze.

Stable:
  ICU 2.0

Implements BreakIterator.

## Friends And Related Function Documentation

friend class BreakIterator`[friend]`

Internal:
  Do not use. This API is for internal use only.

Definition at line 210 of file rbbi.h.

## Field Documentation

int32_t RuleBasedBreakIterator::fBreakType`[protected]`

The type of the break iterator, or -1 if it has not been set.

Internal:
  Do not use. This API is for internal use only.

Definition at line 166 of file rbbi.h.

int32_t* RuleBasedBreakIterator::fCachedBreakPositions`[protected]`

When a range of characters is divided up using the dictionary, the break positions that are discovered are stored here, preventing us from having to use either the dictionary or the state table again until the iterator leaves this range of text.

Has the most impact for line breaking.

Internal:
  Do not use. This API is for internal use only.

Definition at line 128 of file rbbi.h.

CharacterIterator* RuleBasedBreakIterator::fCharIter`[protected]`

A character iterator that refers to the same text as the UText, above.

Only included for compatibility with old API, which was based on CharacterIterators. Value may be adopted from outside, or one of fSCharIter or fDCharIter, below.

Definition at line 79 of file rbbi.h.

RBBIDataWrapper* RuleBasedBreakIterator::fData`[protected]`

The rule data for this BreakIterator instance.

Internal:
  Do not use. This API is for internal use only.

Definition at line 99 of file rbbi.h.

uint32_t RuleBasedBreakIterator::fDictionaryCharCount`[protected]`

Counter for the number of characters encountered with the "dictionary" flag set.

Internal:
  Do not use. This API is for internal use only.

Definition at line 119 of file rbbi.h.

UStack* RuleBasedBreakIterator::fLanguageBreakEngines`[protected]`

If present, UStack of LanguageBreakEngine objects that might handle dictionary characters.

Searched from top to bottom to find an object to handle a given character.

Internal:
  Do not use. This API is for internal use only.

Definition at line 150 of file rbbi.h.

int32_t RuleBasedBreakIterator::fLastRuleStatusIndex`[protected]`

Index of the Rule {tag} values for the most recent match.

Internal:
  Do not use. This API is for internal use only.

Definition at line 104 of file rbbi.h.

UBool RuleBasedBreakIterator::fLastStatusIndexValid`[protected]`

Rule tag value valid flag.

Some iterator operations don't intrinsically set the correct tag value. This flag lets us lazily compute the value if we are ever asked for it.

Internal:
  Do not use. This API is for internal use only.

Definition at line 112 of file rbbi.h.

int32_t RuleBasedBreakIterator::fNumCachedBreakPositions`[protected]`

The number of elements in fCachedBreakPositions.

Internal:
  Do not use. This API is for internal use only.

Definition at line 134 of file rbbi.h.

int32_t RuleBasedBreakIterator::fPositionInCache`[protected]`

if fCachedBreakPositions is not null, this indicates which item in the cache the current iteration position refers to

Internal:
  Do not use. This API is for internal use only.

Definition at line 141 of file rbbi.h.

StringCharacterIterator* RuleBasedBreakIterator::fSCharIter`[protected]`

When the input text is provided by a UnicodeString, this will point to a characterIterator that wraps that data.

Needed only for the implementation of getText(), a backwards compatibility issue.

Definition at line 86 of file rbbi.h.

UText* RuleBasedBreakIterator::fText`[protected]`

The UText through which this BreakIterator accesses the text.

Internal:
  Do not use. This API is for internal use only.

Definition at line 72 of file rbbi.h.

UnhandledEngine* RuleBasedBreakIterator::fUnhandledBreakEngine`[protected]`

If present, the special LanguageBreakEngine used for handling characters that are in the dictionary set, but not handled by any LangugageBreakEngine.

Internal:
  Do not use. This API is for internal use only.

Definition at line 159 of file rbbi.h.

The documentation for this class was generated from the following file:

- rbbi.h